/*
 OKS_Insave_to_Starts.js
----------------------------------------------------------------------------
 (C)2022 OKS兄貴P
 This software is released under the MIT License.
 http://opensource.org/licenses/mit-license.php
----------------------------------------------------------------------------

  ver 0.5 2022/10/7 初版
----------------------------------------------------------------------------

*/

/*:
 * * @plugindesc セーブがないときタイトルをスキップします

 * @target MZ
 * @author OKS兄貴P
 *
 * @param insave
 * @text 有効化
 * @desc する：true / しない：false
 * @default true
 * @type boolean
 *  
 * 
 * @help
 * 初めてゲームを始めるなど、セーブデータが不在のとき
 * 自動でタイトルをスキップできます。
 * ツクールMZ用です。
 * 
 *  * 利用規約：
 *  作者に無断で改変、再配布が可能で、利用形態（商用、18禁利用等）
 *  についても制限はありません。
 * 
 */

(() => {
  //名前等
  "use strict";
  const PLUGIN_NAME = document.currentScript.src.match(/^.*\/(.*).js$/)[1];
//  const PARAM = PluginManager.parameters(PLUGIN_NAME);
  const insave = Boolean(PluginManager.parameters(PLUGIN_NAME));
//  const InsaveToStarts = PARAM["insave"] === "true";
  
  //事前準備
  const skipTitle = (insave) => {
    

    const moveToSceneMap = (isContinue = false) => {
      SceneManager.goto(Scene_Map);
      isContinue && $gameSystem.onAfterLoad();
    };
    const noSave = () => !DataManager.isAnySavefileExists();

    const latestSavefileId = (manualPriority) => {
      if (manualPriority) return DataManager.latestSavefileId();
      const { _globalInfo } = DataManager;
      return _globalInfo.findIndex(
        (x) =>
          x &&
          x.timestamp ===
            Math.max(..._globalInfo.filter(Boolean).map((x) => x.timestamp))
      );
    };


  //実行内容
  const toNewGame = () =>{
    DataManager.setupNewGame();
    moveToSceneMap();
  }

//場合分け
      switch (insave){
        case true:
         if(noSave()){
         return toNewGame();
         }else{
         }
         break;
        case false:
         break;
        default:
          console.error('Hello error.');
          console.log({insave});
         break;
      }
 };
  //ここから(start関数)
  Scene_Boot = class extends Scene_Boot {
    start() {
      super.start(arguments);
      skipTitle(insave);
    }
  };
})();